Index: soft/giet_vm/giet_boot/boot.c
===================================================================
--- soft/giet_vm/giet_boot/boot.c	(revision 490)
+++ soft/giet_vm/giet_boot/boot.c	(revision 493)
@@ -1520,20 +1116,8 @@
              task_id++) 
         {
-            // compute the cluster coordinates & local processor index
-            unsigned int x          = cluster[task[task_id].clusterid].x;
-            unsigned int y          = cluster[task[task_id].clusterid].y;
-            unsigned int cluster_xy = (x<<Y_WIDTH) + y;
-            unsigned int lpid       = task[task_id].proclocid;                 
-
-#if BOOT_DEBUG_SCHED
-_puts("\n[BOOT DEBUG] Initialise context for task ");
-_puts( task[task_id].name );
-_puts(" in vspace ");
-_puts( vspace[vspace_id].name );
-_puts("\n");
-#endif
-            // compute gpid (global processor index) and scheduler base address
-            unsigned int gpid = (cluster_xy << P_WIDTH) + lpid;
-            psched            = _schedulers[x][y][lpid];
+            // get the required task placement coordinates [x,y,p]
+            unsigned int req_x      = cluster[task[task_id].clusterid].x;
+            unsigned int req_y      = cluster[task[task_id].clusterid].y;
+            unsigned int req_p      = task[task_id].proclocid;                 
 
             // ctx_sr : value required before an eret instruction
@@ -1541,8 +1125,8 @@
 
             // ctx_ptpr : page table physical base address (shifted by 13 bit)
-            unsigned int ctx_ptpr = (unsigned int)(_ptabs_paddr[vspace_id][x][y] >> 13);
+            unsigned int ctx_ptpr = (_ptabs_paddr[vspace_id][req_x][req_y] >> 13);
 
             // ctx_ptab : page_table virtual base address
-            unsigned int ctx_ptab = _ptabs_vaddr[vspace_id][x][y];
+            unsigned int ctx_ptab = _ptabs_vaddr[vspace_id][req_x][req_y];
 
             // ctx_epc : Get the virtual address of the memory location containing
@@ -1556,84 +1140,246 @@
             unsigned int ctx_sp = vobj[vobj_id].vbase + vobj[vobj_id].length;
 
-            // get local task index in scheduler
-            unsigned int ltid = psched->tasks;
-
             // get vspace thread index
             unsigned int thread_id = task[task_id].trdid;
 
-            if (ltid >= IDLE_TASK_INDEX) 
+            // loop on the local processors
+            for ( lpid = 0 ; lpid < nprocs ; lpid++ )
             {
-                _puts("\n[BOOT ERROR] in boot_schedulers_init() : ");
-                _putd( ltid );
-                _puts(" tasks allocated to processor ");
-                _putd( gpid );
-                _puts(" / max is ");
-                _putd( IDLE_TASK_INDEX );
-                _puts("\n");
+                if ( (x == req_x) && (y == req_y) && (req_p == lpid) )   // fit
+                {
+                    // pointer on selected scheduler
+                    psched = _schedulers[x][y][lpid];
+
+                    // get local task index in scheduler
+                    unsigned int ltid = psched->tasks;
+
+                    // update the "tasks" and "current" fields in scheduler:
+                    psched->tasks   = ltid + 1;
+                    psched->current = 0;
+
+                    // initializes the task context 
+                    psched->context[ltid][CTX_CR_ID]     = 0;
+                    psched->context[ltid][CTX_SR_ID]     = ctx_sr;
+                    psched->context[ltid][CTX_SP_ID]     = ctx_sp;
+                    psched->context[ltid][CTX_EPC_ID]    = ctx_epc;
+                    psched->context[ltid][CTX_PTPR_ID]   = ctx_ptpr;
+                    psched->context[ltid][CTX_PTAB_ID]   = ctx_ptab;
+                    psched->context[ltid][CTX_LTID_ID]   = ltid;
+                    psched->context[ltid][CTX_GTID_ID]   = task_id;
+                    psched->context[ltid][CTX_TRDID_ID]  = thread_id;
+                    psched->context[ltid][CTX_VSID_ID]   = vspace_id;
+                    psched->context[ltid][CTX_RUN_ID]    = 1;
+
+                    psched->context[ltid][CTX_TTY_ID]    = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_CMA_FB_ID] = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_CMA_RX_ID] = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_CMA_TX_ID] = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_NIC_RX_ID] = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_NIC_TX_ID] = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_TIM_ID]    = 0xFFFFFFFF;
+                    psched->context[ltid][CTX_HBA_ID]    = 0xFFFFFFFF;
+
+#if BOOT_DEBUG_SCHED
+_printf("\nTask %s in vspace %s allocated to P[%d,%d,%d]\n"
+        " - ctx[LTID]  = %d\n"
+        " - ctx[SR]    = %x\n"
+        " - ctx[SP]    = %x\n"
+        " - ctx[EPC]   = %x\n"
+        " - ctx[PTPR]  = %x\n"
+        " - ctx[PTAB]  = %x\n"
+        " - ctx[VSID]  = %d\n"
+        " - ctx[TRDID] = %d\n",
+        task[task_id].name,
+        vspace[vspace_id].name,
+        x, y, lpid,
+        psched->context[ltid][CTX_LTID_ID],
+        psched->context[ltid][CTX_SR_ID],
+        psched->context[ltid][CTX_SP_ID],
+        psched->context[ltid][CTX_EPC_ID],
+        psched->context[ltid][CTX_PTPR_ID],
+        psched->context[ltid][CTX_PTAB_ID],
+        psched->context[ltid][CTX_VSID_ID],
+        psched->context[ltid][CTX_TRDID_ID] );
+#endif
+                } // end if FIT
+            } // end for loop on local procs
+        } // end loop on tasks
+    } // end loop on vspaces
+} // end boot_scheduler_init()
+
+
+/////////////////////////////////////////////////////////////////////////////
+// This function loops on all processors in all clusters to display
+// the interrupt vectors for each processor.
+/////////////////////////////////////////////////////////////////////////////
+void boot_sched_irq_display()
+{
+    unsigned int         cx;
+    unsigned int         cy;
+    unsigned int         lpid;
+    unsigned int         slot;
+    unsigned int         entry;
+
+    mapping_header_t*    header  = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_cluster_t*   cluster = _get_cluster_base(header);
+
+    static_scheduler_t*  psched; 
+
+    for ( cx = 0 ; cx < X_SIZE ; cx++ )
+    {
+        for ( cy = 0 ; cy < Y_SIZE ; cy++ )
+        {
+            unsigned int cluster_id = (cx * Y_SIZE) + cy;
+            unsigned int nprocs = cluster[cluster_id].procs;
+
+            for ( lpid = 0 ; lpid < nprocs ; lpid++ )
+            {
+                psched = _schedulers[cx][cy][lpid];
+        
+                _printf("\n[BOOT] scheduler for proc[%d,%d,%d] : ntasks = %d\n",
+                        cx , cy , lpid , psched->tasks );
+
+                for ( slot = 0 ; slot < 32 ; slot++ )
+                {
+                    entry = psched->hwi_vector[slot];
+                    if ( entry & 0x80000000 ) 
+                    _printf(" - HWI %d / isrtype = %d / channel = %d\n",
+                            slot , (entry & 0xFFFF) , ((entry >> 16) & 0x7FFF) );
+                }
+                for ( slot = 0 ; slot < 32 ; slot++ )
+                {
+                    entry = psched->wti_vector[slot];
+                    if ( entry & 0x80000000 ) 
+                    _printf(" - WTI %d / isrtype = %d / channel = %d\n",
+                            slot , (entry & 0xFFFF) , ((entry >> 16) & 0x7FFF) );
+                }
+                for ( slot = 0 ; slot < 32 ; slot++ )
+                {
+                    entry = psched->pti_vector[slot];
+                    if ( entry & 0x80000000 ) 
+                    _printf(" - PTI %d / isrtype = %d / channel = %d\n",
+                            slot , (entry & 0xFFFF) , ((entry >> 16) & 0x7FFF) );
+                }
+            }
+        }
+    } 
+}  // end boot_sched_display()
+
+
+/////////////////////////////////////////////////////////////////////////////
+// This function complete the schedulers initialisation when the platform
+// contains a PIC component in the IO cluster.
+// It is executed by P[0][0][0] only.
+// It scan HWIs connected to PIC for Round Robin allocation to processors,
+// as WTI. It allocates one WTI per processor, starting from P[0,0,0], 
+// and increments (cluster_id, lpid) as required.
+/////////////////////////////////////////////////////////////////////////////
+void boot_pic_wti_init()
+{
+    mapping_header_t*    header  = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_cluster_t*   cluster = _get_cluster_base(header);
+    mapping_periph_t*    periph  = _get_periph_base(header);
+    mapping_irq_t*       irq     = _get_irq_base(header);
+
+    unsigned int         periph_id;   // peripheral index in mapping_info
+    unsigned int         irq_id;      // irq index in mapping_info
+
+    // get cluster_io index in mapping
+    unsigned int         x_io       = header->x_io;  
+    unsigned int         y_io       = header->y_io;  
+    unsigned int         cluster_io = (x_io * Y_SIZE) + y_io; 
+    
+    // scan peripherals in cluster_io to find PIC 
+    mapping_periph_t*    pic = NULL;
+
+    for ( periph_id = cluster[cluster_io].periph_offset ;
+          periph_id < cluster[cluster_io].periph_offset + cluster[cluster_io].periphs;
+          periph_id++ )
+    {
+        if ( periph[periph_id].type == PERIPH_TYPE_PIC ) 
+        {
+            pic = &periph[periph_id];
+            break;
+        }
+    }
+
+    if ( pic == NULL )  return;
+
+    // initialize WTI channel allocators in all clusters
+    unsigned int x;
+    unsigned int y;
+    for ( x = 0 ; x < X_SIZE ; x++ )
+    {
+        for ( y = 0 ; y < Y_SIZE ; y++ )
+        {
+            _wti_channel_alloc[x][y] = NB_PROCS_MAX;
+        }
+    }
+
+    // scan IRQS defined in PIC
+    unsigned int  cluster_id = 0;
+    unsigned int  lpid       = 0;
+    unsigned int  cx         = cluster[cluster_id].x;
+    unsigned int  cy         = cluster[cluster_id].y;
+
+    for ( irq_id = pic->irq_offset ;
+          irq_id < pic->irq_offset + pic->irqs ;
+          irq_id++ )
+    {
+        // compute next values for cluster_id, lpid, cx, cy
+        // if no more WTI allocatable in current cluster
+        unsigned int overflow = 0;
+
+        while ( (lpid >= cluster[cluster_id].procs) ||
+                (_wti_channel_alloc[cx][cy] >= 16) )
+        {
+            cluster_id = (cluster_id + 1) % (X_SIZE*Y_SIZE);
+            cx         = cluster[cluster_id].x;
+            cy         = cluster[cluster_id].y;
+            lpid       = 0;
+
+            overflow++;
+
+            if ( overflow > 1024 )
+            {
+                _printf("\n[BOOT ERROR] Not enough processors for external IRQs\n");
                 _exit();
             }
-
-            // update the "tasks" and "current" fields in scheduler:
-            // the first task to execute is task 0 as soon as there is at least
-            // one task allocated to processor. 
-            psched->tasks   = ltid + 1;
-            psched->current = 0;
-
-            // initializes the task context 
-            psched->context[ltid][CTX_CR_ID]     = 0;
-            psched->context[ltid][CTX_SR_ID]     = ctx_sr;
-            psched->context[ltid][CTX_SP_ID]     = ctx_sp;
-            psched->context[ltid][CTX_EPC_ID]    = ctx_epc;
-            psched->context[ltid][CTX_PTPR_ID]   = ctx_ptpr;
-            psched->context[ltid][CTX_PTAB_ID]   = ctx_ptab;
-            psched->context[ltid][CTX_LTID_ID]   = ltid;
-            psched->context[ltid][CTX_GTID_ID]   = task_id;
-            psched->context[ltid][CTX_TRDID_ID]  = thread_id;
-            psched->context[ltid][CTX_VSID_ID]   = vspace_id;
-            psched->context[ltid][CTX_RUN_ID]    = 1;
-
-            psched->context[ltid][CTX_TTY_ID]    = 0xFFFFFFFF;
-            psched->context[ltid][CTX_CMA_FB_ID] = 0xFFFFFFFF;
-            psched->context[ltid][CTX_CMA_RX_ID] = 0xFFFFFFFF;
-            psched->context[ltid][CTX_CMA_TX_ID] = 0xFFFFFFFF;
-            psched->context[ltid][CTX_NIC_RX_ID] = 0xFFFFFFFF;
-            psched->context[ltid][CTX_NIC_TX_ID] = 0xFFFFFFFF;
-            psched->context[ltid][CTX_TIM_ID]    = 0xFFFFFFFF;
-            psched->context[ltid][CTX_HBA_ID]    = 0xFFFFFFFF;
+        } 
+        // allocate a WTI to processor defined by (cluster_id,lpid)
+        unsigned int type    = irq[irq_id].srctype;
+        unsigned int srcid   = irq[irq_id].srcid;
+        unsigned int isr     = irq[irq_id].isr & 0xFFFF;
+        unsigned int channel = irq[irq_id].channel << 16;
+
+        if ( (type != IRQ_TYPE_HWI) || (srcid > 31) )
+        {
+            _printf("\n[BOOT ERROR] in boot_pic_wti_init() Bad IRQ type\n");
+            _exit();
+        }
+
+        // get scheduler address for selected processor
+        static_scheduler_t* psched = _schedulers[cx][cy][lpid];
+
+        // update WTI vector for selected processor
+        unsigned int index            = _wti_channel_alloc[cx][cy];
+        psched->wti_vector[index]     = isr | channel | 0x80000000;
+
+        // update IRQ fields in mapping for PIC initialisation
+        irq[irq_id].dest_id = index;
+        irq[irq_id].dest_xy = (cx << Y_WIDTH) + cy;
+
+        // update pointers
+        _wti_channel_alloc[cx][cy] = index + 1;
+        lpid                       = lpid + 1;
+
+    }  // end for IRQs
 
 #if BOOT_DEBUG_SCHED
-_puts("\nTask ");
-_putd( task_id );
-_puts(" allocated to processor[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts(",");
-_putd( lpid );
-_puts("]\n  - ctx[LTID]   = ");
-_putd( psched->context[ltid][CTX_LTID_ID] );
-_puts("\n  - ctx[SR]     = ");
-_putx( psched->context[ltid][CTX_SR_ID] );
-_puts("\n  - ctx[SP]     = ");
-_putx( psched->context[ltid][CTX_SP_ID] );
-_puts("\n  - ctx[EPC]    = ");
-_putx( psched->context[ltid][CTX_EPC_ID] );
-_puts("\n  - ctx[PTPR]   = ");
-_putx( psched->context[ltid][CTX_PTPR_ID] );
-_puts("\n  - ctx[PTAB]   = ");
-_putx( psched->context[ltid][CTX_PTAB_ID] );
-_puts("\n  - ctx[GTID]   = ");
-_putx( psched->context[ltid][CTX_GTID_ID] );
-_puts("\n  - ctx[VSID]   = ");
-_putx( psched->context[ltid][CTX_VSID_ID] );
-_puts("\n  - ctx[TRDID]  = ");
-_putx( psched->context[ltid][CTX_TRDID_ID] );
-_puts("\n");
-#endif
-
-        } // end loop on tasks
-    } // end loop on vspaces
-} // end boot_schedulers_init()
-
+boot_sched_irq_display();
+#endif
+
+} // end boot_pic_wti_init()
+                
 //////////////////////////////////////////////////////////////////////////////////
 // This function loads the map.bin file from block device.
@@ -1650,12 +1396,10 @@
     if ( fd_id == -1 )
     {
-        _puts("\n[BOOT ERROR] : map.bin file not found \n");
+        _printf("\n[BOOT ERROR] : map.bin file not found \n");
         _exit();
     }
 
 #if BOOT_DEBUG_MAPPING
-_puts("\n[BOOT] map.bin file successfully open at cycle ");
-_putd(_get_proctime());
-_puts("\n");
+_printf("\n[BOOT] map.bin file successfully open at cycle %d\n", _get_proctime() );
 #endif
 
@@ -1665,16 +1409,11 @@
     if ( size > SEG_BOOT_MAPPING_SIZE )
     {
-        _puts("\n[BOOT ERROR] : allocated segment too small for map.bin file\n");
+        _printf("\n[BOOT ERROR] : allocated segment too small for map.bin file\n");
         _exit();
     }
 
 #if BOOT_DEBUG_MAPPING
-_puts("\n[BOOT] map.bin buffer pbase = ");
-_putx( SEG_BOOT_MAPPING_BASE );
-_puts(" / buffer size = ");
-_putx( SEG_BOOT_MAPPING_SIZE );
-_puts(" / file size = ");
-_putx( size );
-_puts("\n");
+_printf("\n[BOOT] map.bin buffer pbase = %x / buffer size = %x / file_size = %x\n",
+        SEG_BOOT_MAPPING_BASE , SEG_BOOT_MAPPING_SIZE , size );
 #endif
 
@@ -1691,12 +1430,10 @@
     if ( ok == -1 )
     {
-        _puts("\n[BOOT ERROR] : unable to load map.bin file \n");
+        _printf("\n[BOOT ERROR] : unable to load map.bin file \n");
         _exit();
     }
 
 #if BOOT_DEBUG_MAPPING
-_puts("\n[BOOT] map.bin file successfully loaded at cycle ");
-_putd(_get_proctime());
-_puts("\n");
+_printf("\n[BOOT] map.bin file successfully loaded at cycle %d\n", _get_proctime() );
 #endif
 
@@ -1710,29 +1447,28 @@
 
 #if BOOT_DEBUG_MAPPING
-unsigned int  word;
 unsigned int  line;
 unsigned int* pointer = (unsigned int*)SEG_BOOT_MAPPING_BASE;
-_puts("\n[BOOT] First block of mapping\n");
+_printf("\n[BOOT] First block of mapping\n");
 for ( line = 0 ; line < 8 ; line++ )
 {
-    for ( word = 0 ; word < 8 ; word++ )
-    {
-        _puts(" | ");
-        _putx( *(pointer + word) );
-    }
-    _puts(" |\n");
+    _printf(" | %x | %x | %x | %x | %x | %x | %x | %x |\n",
+            *(pointer + 0),
+            *(pointer + 1),
+            *(pointer + 2),
+            *(pointer + 3),
+            *(pointer + 4),
+            *(pointer + 5),
+            *(pointer + 6),
+            *(pointer + 7) );
+
     pointer = pointer + 8;
 }
 #endif
-        _puts("\n[BOOT ERROR] Illegal mapping signature: ");
-        _putx(header->signature);
-        _puts("\n");
+        _printf("\n[BOOT ERROR] Illegal mapping signature: %x\n", header->signature );
         _exit();
     }
 
 #if BOOT_DEBUG_MAPPING
-_puts("\n[BOOT] map.bin file checked at cycle ");
-_putd(_get_proctime());
-_puts("\n");
+_printf("\n[BOOT] map.bin file checked at cycle %d\n", _get_proctime() );
 #endif
 
@@ -1770,9 +1506,6 @@
 
 #if BOOT_DEBUG_ELF
-_puts("\n[BOOT DEBUG] Start searching file ");
-_puts( pathname );
-_puts(" at cycle ");
-_putd( _get_proctime() );
-_puts("\n");
+_printf("\n[BOOT] Start searching file %s at cycle %d\n", 
+        pathname, _get_proctime() );
 #endif
 
@@ -1783,7 +1516,5 @@
     if ( fd_id < 0 )
     {
-        _puts("\n[BOOT ERROR] load_one_elf_file() : ");
-        _puts( pathname );
-        _puts(" not found\n");
+        _printf("\n[BOOT ERROR] load_one_elf_file() : %s not found\n", pathname );
         _exit();
     }
@@ -1792,11 +1523,7 @@
     if ( fat.fd[fd_id].file_size > GIET_ELF_BUFFER_SIZE )
     {
-        _puts("\n[BOOT ERROR] in load_one_elf_file() : ");
-        _puts( pathname );
-        _puts(" size = ");
-        _putx( fat.fd[fd_id].file_size );
-        _puts("\n exceeds the GIET_ELF_BUFFERSIZE = ");
-        _putx( GIET_ELF_BUFFER_SIZE );
-        _puts("\n");
+        _printf("\n[BOOT ERROR] in load_one_elf_file() : %s / size = %x "
+                "larger than GIET_ELF_BUFFER_SIZE = %x\n",
+                pathname , fat.fd[fd_id].file_size , GIET_ELF_BUFFER_SIZE );
         _exit();
     }
@@ -1814,7 +1541,6 @@
                    0 ) != nsectors )
     {
-        _puts("\n[BOOT ERROR] load_one_elf_file() : unexpected EOF for file ");
-        _puts( pathname );
-        _puts("\n");   
+        _printf("\n[BOOT ERROR] load_one_elf_file() : unexpected EOF for file %s\n",
+                pathname );
         _exit();
     }
@@ -1828,7 +1554,6 @@
          (elf_header_ptr->e_ident[EI_MAG3] != ELFMAG3) )
     {
-        _puts("\n[BOOT ERROR] load_elf() : file ");
-        _puts( pathname );
-        _puts(" does not use ELF format\n");   
+        _printf("\n[BOOT ERROR] load_elf() : file %s does not use ELF format\n",
+                pathname );
         _exit();
     }
@@ -1838,7 +1563,6 @@
     if( pht_index == 0 )
     {
-        _puts("\n[BOOT ERROR] load_one_elf_file() : file ");
-        _puts( pathname );
-        _puts(" does not contain loadable segment\n");   
+        _printf("\n[BOOT ERROR] load_one_elf_file() : file %s "
+                "does not contain loadable segment\n", pathname );
         _exit();
     }
@@ -1847,10 +1571,4 @@
     // get number of segments
     unsigned int nsegments   = elf_header_ptr->e_phnum;
-
-    _puts("\n[BOOT] File ");
-    _puts( pathname );
-    _puts(" loaded at cycle ");
-    _putd( _get_proctime() );
-    _puts("\n");
 
     // Loop on loadable segments in the .elf file
@@ -1866,20 +1584,12 @@
 
 #if BOOT_DEBUG_ELF
-_puts(" - segment ");
-_putd( seg_id );
-_puts(" / vaddr = ");
-_putx( seg_vaddr );
-_puts(" / file_size = ");
-_putx( seg_filesz );
-_puts("\n");
+_printf("\n[BOOT] Segment %d : vaddr = %x / size = %x\n",
+        seg_id , seg_vaddr , seg_filesz );
 #endif
 
             if( seg_memsz < seg_filesz )
             {
-                _puts("\n[BOOT ERROR] load_one_elf_file() : segment at vaddr = ");
-                _putx( seg_vaddr );
-                _puts(" in file ");
-                _puts( pathname );
-                _puts(" has memsz < filesz \n");   
+                _printf("\n[BOOT ERROR] load_one_elf_file() : segment at vaddr = %x"
+                        " in file %s has memsize < filesize \n", seg_vaddr, pathname );
                 _exit();
             }
@@ -1889,5 +1599,6 @@
             {
                 unsigned int i; 
-                for( i = seg_filesz ; i < seg_memsz ; i++ ) boot_elf_buffer[i+seg_offset] = 0;
+                for( i = seg_filesz ; i < seg_memsz ; i++ ) 
+                   boot_elf_buffer[i+seg_offset] = 0;
             } 
 
@@ -1922,23 +1633,13 @@
                     
 #if BOOT_DEBUG_ELF
-_puts("   loaded into vseg ");
-_puts( vseg[vseg_id].name );
-_puts(" at paddr = ");
-_putl( seg_paddr );
-_puts(" (buffer size = ");
-_putx( seg_size );
-_puts(")\n");
+_printf("   loaded into vseg %s at paddr = %l / buffer size = %x\n",
+        vseg[vseg_id].name , seg_paddr , seg_size );
 #endif
                     // check vseg size
                     if ( seg_size < seg_filesz )
                     {
-                        _puts("\n[BOOT ERROR] in load_one_elf_file()\n");
-                        _puts("vseg ");
-                        _puts( vseg[vseg_id].name );
-                        _puts(" is to small for loadable segment ");
-                        _putx( seg_vaddr );
-                        _puts(" in file ");
-                        _puts( pathname );
-                        _puts(" \n");   
+                        _printf("\n[BOOT ERROR] in load_one_elf_file() : vseg %s "
+                                "is to small for loadable segment %x in file %s\n",
+                                vseg[vseg_id].name , seg_vaddr , pathname );
                         _exit();
                     }
@@ -1966,11 +1667,8 @@
             if ( found == 0 )
             {
-                _puts("\n[BOOT ERROR] in load_one_elf_file()\n");
-                _puts("vseg for loadable segment ");
-                _putx( seg_vaddr );
-                _puts(" in file ");
-                _puts( pathname );
-                _puts(" not found: \n");   
-                _puts(" check consistency between the .py and .ld files...\n");
+                _printf("\n[BOOT ERROR] in load_one_elf_file() : vseg for loadable "
+                        "segment %x in file %s not found "
+                        "check consistency between the .py and .ld files\n",
+                        seg_vaddr, pathname );
                 _exit();
             }
@@ -1980,4 +1678,7 @@
     // close .elf file
     _fat_close( fd_id );
+
+    _printf("\n[BOOT] File %s loaded at cycle %d\n", 
+            pathname , _get_proctime() );
 
 } // end load_one_elf_file()
@@ -2018,5 +1719,5 @@
     if (found == 0)
     {
-        _puts("[BOOT ERROR] boot_elf_load() : kernel.elf file not found\n");
+        _printf("\n[BOOT ERROR] boot_elf_load() : kernel.elf file not found\n");
         _exit();
     }
@@ -2047,7 +1748,6 @@
         if (found == 0)
         {
-            _puts("[BOOT ERROR] boot_elf_load() : .elf file not found for vspace ");
-            _puts( vspace[vspace_id].name );
-            _puts("\n");
+            _printf("\n[BOOT ERROR] boot_elf_load() : "
+                    ".elf file not found for vspace %s\n", vspace[vspace_id].name );
             _exit();
         }
@@ -2090,9 +1790,5 @@
 
 #if BOOT_DEBUG_PERI
-_puts("\n[BOOT DEBUG] Peripherals initialisation in cluster[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("]\n");
+_printf("\n[BOOT] Peripherals initialisation in cluster[%d,%d]\n", x , y );
 #endif
 
@@ -2171,19 +1867,6 @@
 
 #if BOOT_DEBUG_PERI
-unsigned int address = _pic_get_register( channel_id, IOPIC_ADDRESS );
-unsigned int extend  = _pic_get_register( channel_id, IOPIC_EXTEND  );
-_puts("    hwi_index = ");
-_putd( hwi_id );
-_puts(" / wti_index = ");
-_putd( wti_id );
-_puts(" / vaddr = ");
-_putx( vaddr );
-_puts(" in cluster[");
-_putd( cluster_xy >> Y_WIDTH );
-_puts(",");
-_putd( cluster_xy & ((1<<Y_WIDTH)-1) );
-_puts("] / checked_xcu_paddr = ");
-_putl( (paddr_t)address + (((paddr_t)extend)<<32) );
-_puts("\n");
+_printf("[BOOT] PIC : hwi_index = %d => wti_index = %d for XCU[%d,%d]\n",
+        hwi_id , wti_id , cluster_xy >> Y_WIDTH , cluster_xy & ((1<<Y_WIDTH)-1) ); 
 #endif
                     }
@@ -2194,9 +1877,5 @@
 
 #if BOOT_DEBUG_PERI
-_puts("\n[BOOT DEBUG] Coprocessors initialisation in cluster[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("]\n");
+_printf("\n[BOOT] Coprocessors initialisation in cluster[%d,%d]\n", x , y );
 #endif
 
@@ -2206,12 +1885,4 @@
               cluster[cluster_id].coprocs; coproc_id++ ) 
         {
-
-#if BOOT_DEBUG_PERI
-_puts("- coprocessor name : ");
-_puts(coproc[coproc_id].name);
-_puts(" / nb ports = ");
-_putd((unsigned int) coproc[coproc_id].ports);
-_puts("\n");
-#endif
             // loop on the coprocessor ports
             for ( cp_port_id = coproc[coproc_id].port_offset;
@@ -2241,13 +1912,5 @@
                               cp_port[cp_port_id].direction, 
                               pbase );
-#if BOOT_DEBUG_PERI
-_puts("     port direction: ");
-_putd( (unsigned int)cp_port[cp_port_id].direction );
-_puts(" / mwmr_channel_pbase = ");
-_putl( pbase );
-_puts(" / name = ");
-_puts(vobj[vobj_id].name);
-_puts("\n"); 
-#endif
+
             } // end for cp_ports
         } // end for coprocs
@@ -2255,10 +1918,10 @@
 } // end boot_peripherals_init()
 
-/////////////////////////////////////////////////////////////////////////
-// This function initialises the physical memory allocators in each
-// cluster containing a RAM pseg.
-// it is handled by the processor[x][y][0]
-/////////////////////////////////////////////////////////////////////////
-void boot_pmem_init() 
+///////////////////////////////////////////////////////////////////////////////////////
+// This function is executed in parallel by all processors[x][y][0].
+// It initialises the physical memory allocator in each cluster containing a RAM pseg.
+///////////////////////////////////////////////////////////////////////////////////////
+void boot_pmem_init( unsigned int cx,
+                     unsigned int cy ) 
 {
     mapping_header_t*  header     = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
@@ -2266,56 +1929,47 @@
     mapping_pseg_t*    pseg       = _get_pseg_base(header);
 
-    unsigned int cluster_id;
     unsigned int pseg_id;
     unsigned int procid     = _get_procid();
-    unsigned int x_cluster  = (procid >> (Y_WIDTH + P_WIDTH)) & ((1<<X_WIDTH)-1);
-    unsigned int y_cluster  = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
     unsigned int lpid       = procid & ((1<<P_WIDTH)-1);
-    if(lpid)
-    {
-        _puts("[BOOT ERROR] boot_pmem_init() : error local processor id\n");
+
+    if( lpid )
+    {
+        _printf("\n[BOOT ERROR] boot_pmem_init() : "
+        "P[%d][%d][%d] should not execute it\n", cx, cy, lpid );
         _exit();
-    }      // scan all clusters
-
-    cluster_id = x_cluster * Y_SIZE + y_cluster;
-    // scan the psegs in cluster to find first pseg of type RAM
-    unsigned int pseg_min = cluster[cluster_id].pseg_offset;
-    unsigned int pseg_max = pseg_min + cluster[cluster_id].psegs;
+    }   
+
+    // scan the psegs in local cluster to find  pseg of type RAM
+    unsigned int found      = 0;
+    unsigned int cluster_id = cx * Y_SIZE + cy;
+    unsigned int pseg_min   = cluster[cluster_id].pseg_offset;
+    unsigned int pseg_max   = pseg_min + cluster[cluster_id].psegs;
     for ( pseg_id = pseg_min ; pseg_id < pseg_max ; pseg_id++ )
     {
         if ( pseg[pseg_id].type == PSEG_TYPE_RAM )
         {
-            unsigned int x    = cluster[cluster_id].x;
-            unsigned int y    = cluster[cluster_id].y;
-            if(x != x_cluster || y != y_cluster)
-            {
-                _puts("[BOOT ERROR] boot_pmem_init() : error cluster id \n");
-                _exit();
-            }  
             unsigned int base = (unsigned int)pseg[pseg_id].base;
             unsigned int size = (unsigned int)pseg[pseg_id].length;
-            _pmem_alloc_init( x, y, base, size );
+            _pmem_alloc_init( cx, cy, base, size );
+            found = 1;
 
 #if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("\n[BOOT DEBUG] pmem allocator initialised in cluster[");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("] base = ");
-_putx( base );
-_puts(" / size = ");
-_putx( size );
-_puts("\n");
-_release_lock(&lock_tty);
+_printf("\n[BOOT] pmem allocator initialised in cluster[%d][%d]"
+        " : base = %x / size = %x\n", cx , cy , base , size );
 #endif
             break;
         }
     }
+
+    if ( found == 0 )
+    {
+        _printf("\n[BOOT ERROR] boot_pmem_init() : no RAM in cluster[%d][%d]\n",
+              cx , cy );
+        _exit();
+    }   
 } // end boot_pmem_init()
  
 /////////////////////////////////////////////////////////////////////////
 // This function is the entry point of the boot code for all processors.
-// Most of this code is executed by Processor 0 only.
 /////////////////////////////////////////////////////////////////////////
 void boot_init() 
